(define (di:verify site user pass)
  (let1 session (make-url-session)
    (session 'get (str* "http://www." site))
    (let1 token (string-between (session 'body)
                                "param\"/> <meta content=\""
                                "\" name=\"csrf-token\"")
      (session 'get "http://www.di.fm/login"
               redirect: #f
               post-data: `((authenticity_token . ,token)
                            (|member_session[username]| . ,user)
                            (|member_session[password]| . ,pass)))
      (and
       (string-contains (session 'body) "You are being")
       (begin (session 'get "http://www.di.fm")
              (and (string-contains (session 'body) "\"authenticated\":true")
                   (string-between (session 'body) "listenKey\":\"" "\"")))))))

(define (di:get-channels site prefix site-name keywords)
  (map (lambda (x)
         (rxmatch-let ((rx "^=\"(.*?)\".*?title=\"(.*?)\"") x) (#f cid name)
           (list (str* prefix cid) (html-unescape name) site-name keywords)))
       (tokenize (string-between (get-url (str* "http://www." site))
                                 "<ul id=\"channels\">" "</ul>")
                 (cut string-between* <> "<li data-key" "</li>"))))

(define (di:media-url site cid quality user pass)
  (let1 hq? (string=? "high" quality)
    (if user
        (let ((quality (if hq? "" "_low")))
          (str* "http://listen." site "/premium" quality "/" cid
                    ".pls?listen_key=" (url-quote (di:verify site user pass))))
        (str* "http://listen." site "/public" (if hq? 3 2) "/" cid ".pls"))))

(define (di:format-meta meta)
  (if (or (string-contains-ci meta "sponsored message")
          (string-contains-ci meta "sky.fm radio amtag"))
      ""
      meta))
