(define api-root "http://www.nrj.fr/playerapi/")

(define (nrjfr:get-channels site-id name
                            #!key (cid-pp identity) (desc-pp identity))
  (let ((num (make-counter 1))
        (titlecase/fm (lambda (x) (if (string= "FM" x) x (string-titlecase x)))))
    (filter-map
     (lambda (x)
       (let ((f (lambda (y) (let ((r (alist-get y (cdr x))))
                         (if (null? r) #f (car r))))))
         (and (f 'urlStream)
              `(,(cid-pp (f 'canal))
                (number . ,(num))
                (name . ,(desc-pp (f 'nom)))
                (description . ,name)
                (mediaURL . ,(f 'urlStream))))))
     (cdadr
      (xml->sexp
       (get-url (str* api-root "getWebradiosList?id_site=" site-id)))))))

(define (nrjfr:media-url site-id cid)
  (or
   (((rx "(.*?)(?:\\?.*)$")
     (alist-get
      'mediaURL
      (cdr
       (find (lambda (x) (string= cid (car x))) (nrjfr:get-channels site-id "")))))
    1)
   (error "unknown cid")))

(define (nrjfr:whats-on site-id cid)
  (metaf (rx (str* "canal id=\"" cid "\".*?"
                   "<title><!\\[CDATA\\[(.*?)\\]\\]></title>.*?"
                   "<nom><!\\[CDATA\\[(.*?)\\]\\]></nom>"))
         (get-url (str* api-root "getmetadata?id_site=" site-id))
         reverse: #t))
