;; backend code.ss dsl preprocessing
;;
(define (pp-backend-code code)
  (define (define-sexp? x)
    (and (list? x) (>= (length x) 3) (eq? 'define (car x)) (list? (cadr x))))
  (map
   (lambda (x)
     (if (define-sexp? x)
         (let ((name (caadr x)) (formals (cdadr x)) (body (cddr x)))
           (case name
             ((get-channels search)
              `(define ,name
                 (lambda (,@formals #!rest ___rest) (append* ((lambda () ,@body))))))
             ((media-url whats-on format-meta)
              `(define (,name ,@formals #!rest ___rest) ,@body))
             (else x)))
         x))
   code))

(define (pp-backend-code/string code)
  (with-output-to-string
    (lambda ()
      (for-each write (pp-backend-code (read/string code))))))

;; misc
;;
(define (channel-alist->list x)
  `(,(car x)
    ,@(map (lambda (y) (or (alist-get y (cdr x)) ""))
           '(number name description genre))))

(define (md5hex s) (digest:hex-encode (digest:md5 (digest:string->cbytes s))))

(define random-string/hex
  (let* ((pool (char-set->string char-set:hex-digit))
         (pool-length (string-length pool)))
    (lambda (length)
      (list->string
       (list-tabulate
        length (lambda _ (string-ref pool (random-integer pool-length))))))))
